'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.applyVersionReport = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _mergeVersion;

function _load_mergeVersion() {
  return _mergeVersion = require('../../../consumer/versions-ops/merge-version');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var applyVersionReport = exports.applyVersionReport = function applyVersionReport(components) {
  var addName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var showVersion = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  var tab = addName ? '\t' : '';
  return components.map(function (component) {
    var name = showVersion ? component.id.toString() : component.id.toStringWithoutVersion();
    var files = Object.keys(component.filesStatus).map(function (file) {
      var note = component.filesStatus[file] === (_mergeVersion || _load_mergeVersion()).FileStatus.manual ? (_chalk || _load_chalk()).default.white('automatic merge failed. please fix conflicts manually and then tag the results.') : '';
      return `${tab}${component.filesStatus[file]} ${(_chalk || _load_chalk()).default.bold(file)} ${note}`;
    }).join('\n');
    return `${addName ? name : ''}\n${(_chalk || _load_chalk()).default.cyan(files)}`;
  }).join('\n\n');
};

var Merge = function (_Command) {
  _inherits(Merge, _Command);

  function Merge() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Merge);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Merge.__proto__ || Object.getPrototypeOf(Merge)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'merge <version> <ids...>', _this.description = 'merge changes of different component versions', _this.alias = '', _this.opts = [['o', 'ours', 'in case of a conflict, override the used version with the current modification'], ['t', 'theirs', 'in case of a conflict, override the current modification with the specified version'], ['m', 'manual', 'in case of a conflict, leave the files with a conflict state to resolve them manually later']], _this.loader = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Merge, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 2),
          version = _ref4[0],
          ids = _ref4[1];

      var _ref3$ours = _ref3.ours,
          ours = _ref3$ours === undefined ? false : _ref3$ours,
          _ref3$theirs = _ref3.theirs,
          theirs = _ref3$theirs === undefined ? false : _ref3$theirs,
          _ref3$manual = _ref3.manual,
          manual = _ref3$manual === undefined ? false : _ref3$manual;

      var bitIds = ids.map(function (id) {
        return (_bitId || _load_bitId()).BitId.parse(id);
      });
      var mergeStrategy = (0, (_mergeVersion || _load_mergeVersion()).getMergeStrategy)(ours, theirs, manual);
      return (0, (_consumer || _load_consumer()).merge)(version, bitIds, mergeStrategy);
    }
  }, {
    key: 'report',
    value: function report(_ref5) {
      var components = _ref5.components,
          version = _ref5.version;

      // $FlowFixMe version is set in case of merge command
      var title = `successfully merged components from version ${(_chalk || _load_chalk()).default.bold(version)}\n`;
      // $FlowFixMe components is set in case of merge command
      var componentsStr = applyVersionReport(components);
      return (_chalk || _load_chalk()).default.underline(title) + (_chalk || _load_chalk()).default.green(componentsStr);
    }
  }]);

  return Merge;
}((_command || _load_command()).default);

exports.default = Merge;