'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CompilerEnvType = undefined;

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _envExtension;

function _load_envExtension() {
  return _envExtension = _interopRequireDefault(require('./env-extension'));
}

var _baseExtension;

function _load_baseExtension() {
  return _baseExtension = _interopRequireDefault(require('./base-extension'));
}

var _objects;

function _load_objects() {
  return _objects = require('../scope/objects');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../consumer/component'));
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _consumerBitJson;

function _load_consumerBitJson() {
  return _consumerBitJson = _interopRequireDefault(require('../consumer/bit-json/consumer-bit-json'));
}

var _bitJson;

function _load_bitJson() {
  return _bitJson = _interopRequireDefault(require('../consumer/bit-json'));
}

var _analytics;

function _load_analytics() {
  return _analytics = require('../analytics/analytics');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CompilerEnvType = exports.CompilerEnvType = 'Compiler';

var CompilerExtension = function (_EnvExtension) {
  _inherits(CompilerExtension, _EnvExtension);

  function CompilerExtension(extensionProps) {
    _classCallCheck(this, CompilerExtension);

    extensionProps.envType = CompilerEnvType;

    var _this = _possibleConstructorReturn(this, (CompilerExtension.__proto__ || Object.getPrototypeOf(CompilerExtension)).call(this, extensionProps));

    _this.envType = extensionProps.envType;
    return _this;
  }

  _createClass(CompilerExtension, [{
    key: 'toModelObject',
    value: function toModelObject() {
      (_analytics || _load_analytics()).Analytics.addBreadCrumb('compiler-extension', 'toModelObject');
      var envModelObject = _get(CompilerExtension.prototype.__proto__ || Object.getPrototypeOf(CompilerExtension.prototype), 'toModelObject', this).call(this);
      var modelObject = _extends({}, envModelObject);
      return modelObject;
    }

    /**
     * Write the env files to the file system according to the template dir
     * used for ejecting env for imported component
     * @param {*} param0
     */

  }, {
    key: 'writeFilesToFs',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(_ref) {
        var bitDir = _ref.bitDir,
            ejectedEnvsDirectory = _ref.ejectedEnvsDirectory;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('compiler-extension', 'writeFilesToFs');
                return _context.abrupt('return', _get(CompilerExtension.prototype.__proto__ || Object.getPrototypeOf(CompilerExtension.prototype), 'writeFilesToFs', this).call(this, { bitDir, ejectedEnvsDirectory, envType: this.envType }));

              case 2:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function writeFilesToFs(_x) {
        return _ref2.apply(this, arguments);
      }

      return writeFilesToFs;
    }()

    /**
     * Loading from props (usually from bit.json)
     * @param {*} props
     */
    // $FlowFixMe

  }], [{
    key: 'load',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(props) {
        var envExtensionProps, extension, throws;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('compiler-extension', 'load');
                props.envType = CompilerEnvType;
                // Throw error if compiler not loaded
                props.throws = true;
                _context2.next = 5;
                return _get(CompilerExtension.__proto__ || Object.getPrototypeOf(CompilerExtension), 'load', this).call(this, props);

              case 5:
                envExtensionProps = _context2.sent;
                extension = new CompilerExtension(envExtensionProps);

                if (!extension.loaded) {
                  _context2.next = 11;
                  break;
                }

                throws = true;
                _context2.next = 11;
                return extension.init(throws);

              case 11:
                return _context2.abrupt('return', extension);

              case 12:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function load(_x2) {
        return _ref3.apply(this, arguments);
      }

      return load;
    }()
  }, {
    key: 'loadFromModelObject',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(modelObject, repository
      // $FlowFixMe
      ) {
        var actualObject, envExtensionProps, extension;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('compiler-extension', 'loadFromModelObject');

                if (modelObject) {
                  _context3.next = 3;
                  break;
                }

                return _context3.abrupt('return', undefined);

              case 3:
                actualObject = typeof modelObject === 'string' ? _extends({ envType: CompilerEnvType }, (_baseExtension || _load_baseExtension()).default.transformStringToModelObject(modelObject)) : _extends({ envType: CompilerEnvType }, modelObject);
                _context3.next = 6;
                return _get(CompilerExtension.__proto__ || Object.getPrototypeOf(CompilerExtension), 'loadFromModelObject', this).call(this, actualObject, repository);

              case 6:
                envExtensionProps = _context3.sent;
                extension = new CompilerExtension(envExtensionProps);
                return _context3.abrupt('return', extension);

              case 9:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function loadFromModelObject(_x3, _x4) {
        return _ref4.apply(this, arguments);
      }

      return loadFromModelObject;
    }()

    /**
     * Load the compiler from the correct place
     * If a component has a bit.json with compiler defined take it
     * Else if a component is not authored take if from the models
     * Else, for authored component check if the compiler has been changed
     *
     */

  }, {
    key: 'loadFromCorrectSource',
    value: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(_ref5) {
        var consumerPath = _ref5.consumerPath,
            scopePath = _ref5.scopePath,
            componentOrigin = _ref5.componentOrigin,
            componentFromModel = _ref5.componentFromModel,
            consumerBitJson = _ref5.consumerBitJson,
            componentBitJson = _ref5.componentBitJson,
            context = _ref5.context;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('compiler-extension', 'loadFromCorrectSource');

                if (!componentBitJson) {
                  _context4.next = 5;
                  break;
                }

                if (!componentBitJson.hasCompiler()) {
                  _context4.next = 4;
                  break;
                }

                return _context4.abrupt('return', componentBitJson.loadCompiler(consumerPath, scopePath, context));

              case 4:
                return _context4.abrupt('return', undefined);

              case 5:
                if (!(componentOrigin !== (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED)) {
                  _context4.next = 9;
                  break;
                }

                if (!(componentFromModel && componentFromModel.compiler)) {
                  _context4.next = 8;
                  break;
                }

                return _context4.abrupt('return', componentFromModel.compiler);

              case 8:
                return _context4.abrupt('return', undefined);

              case 9:
                if (!consumerBitJson.hasCompiler()) {
                  _context4.next = 11;
                  break;
                }

                return _context4.abrupt('return', consumerBitJson.loadCompiler(consumerPath, scopePath, context));

              case 11:
                return _context4.abrupt('return', undefined);

              case 12:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function loadFromCorrectSource(_x5) {
        return _ref6.apply(this, arguments);
      }

      return loadFromCorrectSource;
    }()
  }]);

  return CompilerExtension;
}((_envExtension || _load_envExtension()).default);

exports.default = CompilerExtension;