'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path;

function _load_path() {
  return _path = _interopRequireWildcard(require('path'));
}

var _semver;

function _load_semver() {
  return _semver = _interopRequireDefault(require('semver'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _ramda2;

function _load_ramda2() {
  return _ramda2 = require('ramda');
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _pMapSeries;

function _load_pMapSeries() {
  return _pMapSeries = _interopRequireDefault(require('p-map-series'));
}

var _globalConfig;

function _load_globalConfig() {
  return _globalConfig = require('../global-config');
}

var _enrichContextFromGlobal;

function _load_enrichContextFromGlobal() {
  return _enrichContextFromGlobal = _interopRequireDefault(require('../hooks/utils/enrich-context-from-global'));
}

var _componentObjects;

function _load_componentObjects() {
  return _componentObjects = _interopRequireDefault(require('./component-objects'));
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('./models/component'));
}

var _models;

function _load_models() {
  return _models = require('./models');
}

var _remotes;

function _load_remotes() {
  return _remotes = require('../remotes');
}

var _objectRegistrar;

function _load_objectRegistrar() {
  return _objectRegistrar = _interopRequireDefault(require('./object-registrar'));
}

var _utils;

function _load_utils() {
  return _utils = require('../utils');
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _scopeJson;

function _load_scopeJson() {
  return _scopeJson = require('./scope-json');
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('./exceptions');
}

var _environment;

function _load_environment() {
  return _environment = _interopRequireDefault(require('../environment'));
}

var _exceptions2;

function _load_exceptions2() {
  return _exceptions2 = require('./network/exceptions');
}

var _repositories;

function _load_repositories() {
  return _repositories = require('./repositories');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../bit-id');
}

var _component2;

function _load_component2() {
  return _component2 = _interopRequireDefault(require('../consumer/component'));
}

var _componentVersion;

function _load_componentVersion() {
  return _componentVersion = _interopRequireDefault(require('./component-version'));
}

var _objects;

function _load_objects() {
  return _objects = require('./objects');
}

var _componentDependencies;

function _load_componentDependencies() {
  return _componentDependencies = _interopRequireDefault(require('./component-dependencies'));
}

var _versionDependencies;

function _load_versionDependencies() {
  return _versionDependencies = _interopRequireDefault(require('./version-dependencies'));
}

var _sources;

function _load_sources() {
  return _sources = _interopRequireDefault(require('./repositories/sources'));
}

var _consumer;

function _load_consumer() {
  return _consumer = _interopRequireDefault(require('../consumer/consumer'));
}

var _indexer;

function _load_indexer() {
  return _indexer = require('../search/indexer');
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../cli/loader'));
}

var _migrationHelper;

function _load_migrationHelper() {
  return _migrationHelper = require('../migration/migration-helper');
}

var _scopeMigratorManifest;

function _load_scopeMigratorManifest() {
  return _scopeMigratorManifest = _interopRequireDefault(require('./migrations/scope-migrator-manifest'));
}

var _scopeMigrator;

function _load_scopeMigrator() {
  return _scopeMigrator = _interopRequireDefault(require('./migrations/scope-migrator'));
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../cli/loader/loader-messages');
}

var _ciOps;

function _load_ciOps() {
  return _ciOps = _interopRequireDefault(require('./ci-ops'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../logger/logger'));
}

var _componentResolver;

function _load_componentResolver() {
  return _componentResolver = _interopRequireDefault(require('../component-resolver'));
}

var _componentsList;

function _load_componentsList() {
  return _componentsList = _interopRequireDefault(require('../consumer/component/components-list'));
}

var _consumerComponent;

function _load_consumerComponent() {
  return _consumerComponent = _interopRequireDefault(require('../consumer/component/consumer-component'));
}

var _removedComponents;

function _load_removedComponents() {
  return _removedComponents = require('./removed-components');
}

var _graph;

function _load_graph() {
  return _graph = _interopRequireDefault(require('./graph/graph'));
}

var _removeModelComponents;

function _load_removeModelComponents() {
  return _removeModelComponents = _interopRequireDefault(require('./component-ops/remove-model-components'));
}

var _dists;

function _load_dists() {
  return _dists = _interopRequireDefault(require('../consumer/component/sources/dists'));
}

var _specsResults;

function _load_specsResults() {
  return _specsResults = _interopRequireDefault(require('../consumer/specs-results'));
}

var _analytics;

function _load_analytics() {
  return _analytics = require('../analytics/analytics');
}

var _generalError;

function _load_generalError() {
  return _generalError = _interopRequireDefault(require('../error/general-error'));
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var removeNils = (_ramda || _load_ramda()).default.reject((_ramda || _load_ramda()).default.isNil);
var pathHasScope = (0, (_utils || _load_utils()).pathHasAll)([(_constants || _load_constants()).OBJECTS_DIR, (_constants || _load_constants()).SCOPE_JSON]);

var Scope = function () {
  // cache DependencyGraph instance

  function Scope(scopeProps) {
    _classCallCheck(this, Scope);

    this.created = false;

    this.path = scopeProps.path;
    this.scopeJson = scopeProps.scopeJson;
    this.created = scopeProps.created || false;
    this.tmp = scopeProps.tmp || new (_repositories || _load_repositories()).Tmp(this);
    this.sources = scopeProps.sources || new (_sources || _load_sources()).default(this);
    this.objects = scopeProps.objects || new (_objects || _load_objects()).Repository(this, (0, (_objectRegistrar || _load_objectRegistrar()).default)());
  }

  _createClass(Scope, [{
    key: 'getDependencyGraph',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (this._dependencyGraph) {
                  _context.next = 4;
                  break;
                }

                _context.next = 3;
                return (_graph || _load_graph()).default.load(this.objects);

              case 3:
                this._dependencyGraph = _context.sent;

              case 4:
                return _context.abrupt('return', this._dependencyGraph);

              case 5:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getDependencyGraph() {
        return _ref.apply(this, arguments);
      }

      return getDependencyGraph;
    }()
  }, {
    key: 'getPath',
    value: function getPath() {
      return this.path;
    }
  }, {
    key: 'getComponentsPath',
    value: function getComponentsPath() {
      return (_path || _load_path()).join(this.path, Scope.getComponentsRelativePath());
    }

    /**
     * Get the releative components path inside the scope
     * (components such as compilers / testers / extensions)
     * currently components
     */

  }, {
    key: 'getBitPathInComponentsDir',
    value: function getBitPathInComponentsDir(id) {
      return (_path || _load_path()).join(this.getComponentsPath(), id.toFullPath());
    }

    /**
     * Running migration process for scope to update the stores (bit objects) to the current version
     *
     * @param {any} verbose - print debug logs
     * @returns {Object} - wether the process run and wether it successeded
     * @memberof Consumer
     */

  }, {
    key: 'migrate',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(verbose) {
        var scopeVersion, upToDateMsg, rawObjects, resultObjects, validateBeforePersist;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (_logger || _load_logger()).default.debug('running migration process for scope');
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('migrate', 'running migration process for scope');
                if (verbose) console.log('running migration process for scope'); // eslint-disable-line
                // We start to use this process after version 0.10.9, so we assume the scope is in the last production version
                scopeVersion = this.scopeJson.get('version') || '0.10.9';

                if (!(_semver || _load_semver()).default.gte(scopeVersion, (_constants || _load_constants()).BIT_VERSION)) {
                  _context2.next = 10;
                  break;
                }

                upToDateMsg = 'scope version is up to date';

                if (verbose) console.log(upToDateMsg); // eslint-disable-line
                (_logger || _load_logger()).default.debug(upToDateMsg);
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('migrate', upToDateMsg);
                return _context2.abrupt('return', {
                  run: false
                });

              case 10:
                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_MIGRATION);
                _context2.next = 13;
                return this.objects.listRawObjects();

              case 13:
                rawObjects = _context2.sent;
                _context2.next = 16;
                return (0, (_scopeMigrator || _load_scopeMigrator()).default)(scopeVersion, (_scopeMigratorManifest || _load_scopeMigratorManifest()).default, rawObjects, verbose);

              case 16:
                resultObjects = _context2.sent;

                // Add the new / updated objects
                this.objects.addMany(resultObjects.newObjects);
                // Remove old objects
                _context2.next = 20;
                return this.objects.removeMany(resultObjects.refsToRemove);

              case 20:
                // Persists new / remove objects
                validateBeforePersist = false;
                _context2.next = 23;
                return this.objects.persist(validateBeforePersist);

              case 23:
                // Update the scope version
                this.scopeJson.set('version', (_constants || _load_constants()).BIT_VERSION);
                (_logger || _load_logger()).default.debug(`updating scope version to version ${(_constants || _load_constants()).BIT_VERSION}`);
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('migrate', `updating scope version to version ${(_constants || _load_constants()).BIT_VERSION}`);
                _context2.next = 28;
                return this.scopeJson.write(this.getPath());

              case 28:
                (_loader || _load_loader()).default.stop();
                return _context2.abrupt('return', {
                  run: true,
                  success: true
                });

              case 30:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function migrate(_x) {
        return _ref2.apply(this, arguments);
      }

      return migrate;
    }()
  }, {
    key: 'remotes',
    value: function remotes() {
      var self = this;
      function mergeRemotes(globalRemotes) {
        var globalObj = globalRemotes.toPlainObject();
        return (_remotes || _load_remotes()).Remotes.load((0, (_ramda2 || _load_ramda2()).merge)(globalObj, self.scopeJson.remotes));
      }

      return (_globalConfig || _load_globalConfig()).GlobalRemotes.load().then(mergeRemotes);
    }
  }, {
    key: 'describe',
    value: function describe() {
      return {
        name: this.name
      };
    }
  }, {
    key: 'toConsumerComponents',
    value: function toConsumerComponents(components) {
      var _this = this;

      return Promise.all(components.filter(function (comp) {
        return !(comp instanceof (_models || _load_models()).Symlink);
      }).map(function (c) {
        return c.toConsumerComponent(c.latestExisting(_this.objects).toString(), _this.name, _this.objects);
      }));
    }
  }, {
    key: 'list',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3() {
        var showRemoteVersion = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
        var components, consumerComponents, componentsIds, latestVersionsInfo;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.objects.listComponents();

              case 2:
                components = _context3.sent;
                _context3.next = 5;
                return this.toConsumerComponents(components);

              case 5:
                consumerComponents = _context3.sent;

                if (!showRemoteVersion) {
                  _context3.next = 12;
                  break;
                }

                componentsIds = consumerComponents.map(function (component) {
                  return component.id;
                });
                _context3.next = 10;
                return this.fetchRemoteVersions(componentsIds);

              case 10:
                latestVersionsInfo = _context3.sent;

                latestVersionsInfo.forEach(function (componentId) {
                  var component = consumerComponents.find(function (c) {
                    return c.id.toStringWithoutVersion() === componentId.toStringWithoutVersion();
                  });
                  component.latest = componentId.version;
                });

              case 12:
                return _context3.abrupt('return', (_componentsList || _load_componentsList()).default.sortComponentsByName(consumerComponents));

              case 13:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function list() {
        return _ref3.apply(this, arguments);
      }

      return list;
    }()
  }, {
    key: 'listStage',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4() {
        var _this2 = this;

        var components, scopeComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.objects.listComponents(false);

              case 2:
                components = _context4.sent;
                _context4.next = 5;
                return this.toConsumerComponents(components.filter(function (c) {
                  return !c.scope || c.scope === _this2.name;
                }));

              case 5:
                scopeComponents = _context4.sent;
                return _context4.abrupt('return', (_componentsList || _load_componentsList()).default.sortComponentsByName(scopeComponents));

              case 7:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function listStage() {
        return _ref4.apply(this, arguments);
      }

      return listStage;
    }()
  }, {
    key: 'fetchRemoteVersions',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(componentIds) {
        var _this3 = this;

        var externals, remotes;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                externals = componentIds.filter(function (id) {
                  return !id.isLocal(_this3.name);
                });
                _context5.next = 3;
                return this.remotes();

              case 3:
                remotes = _context5.sent;
                return _context5.abrupt('return', remotes.latestVersions(externals, this));

              case 5:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function fetchRemoteVersions(_x3) {
        return _ref5.apply(this, arguments);
      }

      return fetchRemoteVersions;
    }()
  }, {
    key: 'latestVersions',
    value: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6(componentIds) {
        var throwOnFailure = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var components;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                componentIds = componentIds.map(function (componentId) {
                  return (_bitId || _load_bitId()).BitId.parse(componentId.toStringWithoutVersion());
                });
                _context6.next = 3;
                return this.sources.getMany(componentIds);

              case 3:
                components = _context6.sent;
                return _context6.abrupt('return', components.map(function (component) {
                  var componentId = (_bitId || _load_bitId()).BitId.parse(component.id.toString());
                  if (component.component) {
                    componentId.version = component.component.latest();
                  } else {
                    if (throwOnFailure) throw new (_exceptions || _load_exceptions()).ComponentNotFound(component.id.toString());
                    componentId.version = (_constants || _load_constants()).DEFAULT_BIT_VERSION;
                  }
                  return componentId;
                }));

              case 5:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function latestVersions(_x5) {
        return _ref6.apply(this, arguments);
      }

      return latestVersions;
    }()
  }, {
    key: 'importDependencies',
    value: function importDependencies(dependencies) {
      var _this4 = this;

      return new Promise(function (resolve, reject) {
        return _this4.importMany(dependencies).then(resolve).catch(function (e) {
          (_logger || _load_logger()).default.error(`importDependencies got an error: ${JSON.stringify(e)}`);
          if (e instanceof (_exceptions2 || _load_exceptions2()).RemoteScopeNotFound || e instanceof (_exceptions2 || _load_exceptions2()).PermissionDenied) return reject(e);
          return reject(new (_exceptions || _load_exceptions()).DependencyNotFound(e.id));
        });
      });
    }

    /**
     * Build multiple components sequentially, not in parallel.
     *
     * Two reasons why not running them in parallel:
     * 1) when several components have the same environment, it'll try to install them multiple times.
     * 2) npm throws errors when running 'npm install' from several directories
     */

  }, {
    key: 'buildMultiple',
    value: function () {
      var _ref7 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee8(components, consumer, noCache, verbose) {
        var _this5 = this;

        var build;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                (_logger || _load_logger()).default.debug('scope.buildMultiple: sequentially build multiple components');
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('scope.buildMultiple', 'scope.buildMultiple: sequentially build multiple components');
                // Make sure to not start the loader if there are no components to build
                if (components && components.length) {
                  (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_RUNNING_BUILD);
                }

                build = function () {
                  var _ref8 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee7(component) {
                    var buildResults;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee7$(_context7) {
                      while (1) {
                        switch (_context7.prev = _context7.next) {
                          case 0:
                            _context7.next = 2;
                            return component.build({ scope: _this5, consumer, noCache, verbose });

                          case 2:
                            _context7.next = 4;
                            return component.dists.writeDists(component, consumer);

                          case 4:
                            buildResults = _context7.sent;
                            return _context7.abrupt('return', { component: component.id.toString(), buildResults });

                          case 6:
                          case 'end':
                            return _context7.stop();
                        }
                      }
                    }, _callee7, _this5);
                  }));

                  return function build(_x10) {
                    return _ref8.apply(this, arguments);
                  };
                }();

                return _context8.abrupt('return', (0, (_pMapSeries || _load_pMapSeries()).default)(components, build));

              case 5:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function buildMultiple(_x6, _x7, _x8, _x9) {
        return _ref7.apply(this, arguments);
      }

      return buildMultiple;
    }()

    /**
     * when custom-module-resolution is used, the test process needs to set the custom module
     * directory to the dist directory
     */

  }, {
    key: 'injectNodePathIfNeeded',
    value: function injectNodePathIfNeeded(consumer, components) {
      var nodePathDirDist = (_dists || _load_dists()).default.getNodePathDir(consumer);
      // only author components need this injection. for imported the links are built on node_modules
      var isNodePathNeeded = nodePathDirDist && components.some(function (component) {
        return (component.dependencies.isCustomResolvedUsed() || component.devDependencies.isCustomResolvedUsed()) && component.componentMap && component.componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED && !component.dists.isEmpty();
      });
      if (isNodePathNeeded) {
        var getCurrentNodePathWithDirDist = function getCurrentNodePathWithDirDist() {
          if (!process.env.NODE_PATH) return nodePathDirDist;
          var separator = process.env.NODE_PATH.endsWith((_constants || _load_constants()).NODE_PATH_SEPARATOR) ? '' : (_constants || _load_constants()).NODE_PATH_SEPARATOR;
          // $FlowFixMe
          return process.env.NODE_PATH + separator + nodePathDirDist;
        };
        process.env.NODE_PATH = getCurrentNodePathWithDirDist();
        // $FlowFixMe
        require('module').Module._initPaths(); // eslint-disable-line
      }
    }

    /**
     * Test multiple components sequentially, not in parallel.
     *
     * See the reason not to run them in parallel at @buildMultiple()
     */

  }, {
    key: 'testMultiple',
    value: function () {
      var _ref10 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee10(_ref9) {
        var _this6 = this;

        var components = _ref9.components,
            consumer = _ref9.consumer,
            verbose = _ref9.verbose,
            _ref9$rejectOnFailure = _ref9.rejectOnFailure,
            rejectOnFailure = _ref9$rejectOnFailure === undefined ? false : _ref9$rejectOnFailure;
        var test;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                (_logger || _load_logger()).default.debug('scope.testMultiple: sequentially test multiple components');
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('scope.testMultiple', 'scope.testMultiple: sequentially test multiple components');
                // Make sure not starting the loader when there is nothing to test
                if (components && components.length) {
                  (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_RUNNING_SPECS);
                }
                this.injectNodePathIfNeeded(consumer, components);

                test = function () {
                  var _ref11 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee9(component) {
                    var specs;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee9$(_context9) {
                      while (1) {
                        switch (_context9.prev = _context9.next) {
                          case 0:
                            if (component.tester) {
                              _context9.next = 2;
                              break;
                            }

                            return _context9.abrupt('return', { componentId: component.id.toStringWithoutScope(), missingTester: true });

                          case 2:
                            _context9.next = 4;
                            return component.runSpecs({
                              scope: _this6,
                              rejectOnFailure,
                              consumer,
                              verbose
                            });

                          case 4:
                            specs = _context9.sent;
                            return _context9.abrupt('return', { componentId: component.id.toStringWithoutScope(), specs });

                          case 6:
                          case 'end':
                            return _context9.stop();
                        }
                      }
                    }, _callee9, _this6);
                  }));

                  return function test(_x12) {
                    return _ref11.apply(this, arguments);
                  };
                }();

                return _context10.abrupt('return', (0, (_pMapSeries || _load_pMapSeries()).default)(components, test));

              case 6:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function testMultiple(_x11) {
        return _ref10.apply(this, arguments);
      }

      return testMultiple;
    }()

    /**
     * Writes a component as an object into the 'objects' directory
     */

  }, {
    key: 'writeComponentToModel',
    value: function writeComponentToModel(componentObjects) {
      var _this7 = this;

      var objects = componentObjects.toObjects(this.objects);
      (_logger || _load_logger()).default.debug(`writeComponentToModel, writing into the model, Main id: ${objects.component.id()}. It might have dependencies which are going to be written too`);
      (_analytics || _load_analytics()).Analytics.addBreadCrumb('writeComponentToModel', `writeComponentToModel, writing into the model, Main id: ${(_analytics || _load_analytics()).Analytics.hashData(objects.component.id().toString())}. It might have dependencies which are going to be written too`);
      return this.sources.merge(objects).then(function () {
        return _this7.objects.persist();
      });
    }

    /**
     * Writes components as objects into the 'objects' directory
     */

  }, {
    key: 'writeManyComponentsToModel',
    value: function () {
      var _ref12 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee11(componentsObjects) {
        var _this8 = this;

        var persist = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var manyObjects;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                manyObjects = componentsObjects.map(function (componentObjects) {
                  return componentObjects.toObjects(_this8.objects);
                });

                (_logger || _load_logger()).default.debug(`writeComponentToModel, writing into the model, ids: ${manyObjects.map(function (objects) {
                  return objects.component.id();
                }).join(', ')}. They might have dependencies which are going to be written too`);
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('writeManyComponentsToModel', `writeComponentToModel, writing into the model, ids: ${(_analytics || _load_analytics()).Analytics.hashData(manyObjects.map(function (objects) {
                  return objects.component.id();
                }).join(', '))}. They might have dependencies which are going to be written too`);
                _context11.next = 5;
                return Promise.all(manyObjects.map(function (objects) {
                  return _this8.sources.merge(objects);
                }));

              case 5:
                return _context11.abrupt('return', persist ? this.objects.persist() : Promise.resolve());

              case 6:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function writeManyComponentsToModel(_x14) {
        return _ref12.apply(this, arguments);
      }

      return writeManyComponentsToModel;
    }()

    /**
     * When exporting components with dependencies to a bare-scope, some of the dependencies may be created locally and as
     * as result their scope-name is null. Once the bare-scope gets the components, it needs to convert these scope names
     * to the bare-scope name.
     * Since the changes it does affect the Version objects, the version REF of a component, needs to be changed as well.
     */

  }, {
    key: '_convertNonScopeToCorrectScope',
    value: function _convertNonScopeToCorrectScope(componentsObjects, remoteScope) {
      var _this9 = this;

      var changeScopeIfNeeded = function changeScopeIfNeeded(dependencyId) {
        if (!dependencyId.scope) {
          var depId = (_component || _load_component()).default.fromBitId(dependencyId);
          // todo: use 'load' for async and switch the foreach with map.
          var dependencyObject = _this9.objects.loadSync(depId.hash());
          if (dependencyObject instanceof (_models || _load_models()).Symlink) {
            dependencyId.scope = dependencyObject.realScope;
          } else {
            dependencyId.scope = remoteScope;
          }
        }
      };

      componentsObjects.objects.forEach(function (object) {
        if (object instanceof (_models || _load_models()).Version) {
          var hashBefore = object.hash().toString();
          object.getAllDependencies().forEach(function (dependency) {
            changeScopeIfNeeded(dependency.id);
          });
          object.getAllFlattenedDependencies().forEach(function (dependency) {
            changeScopeIfNeeded(dependency);
          });
          var hashAfter = object.hash().toString();
          if (hashBefore !== hashAfter) {
            (_logger || _load_logger()).default.debug(`switching ${componentsObjects.component.id()} version hash from ${hashBefore} to ${hashAfter}`);
            (_analytics || _load_analytics()).Analytics.addBreadCrumb('_convertNonScopeToCorrectScope', `switching ${(_analytics || _load_analytics()).Analytics.hashData(componentsObjects.component.id().toString())} version hash from ${(_analytics || _load_analytics()).Analytics.hashData(hashBefore)} to ${(_analytics || _load_analytics()).Analytics.hashData(hashAfter)}`);
            var versions = componentsObjects.component.versions;
            Object.keys(versions).forEach(function (version) {
              if (versions[version].toString() === hashBefore) {
                versions[version] = (_objects || _load_objects()).Ref.from(hashAfter);
              }
            });
          }
        }
      });

      componentsObjects.component.scope = remoteScope;
    }
  }, {
    key: '_mergeObjects',
    value: function () {
      var _ref13 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee13(manyObjects) {
        var _this10 = this;

        var mergeResults, componentsWithConflicts, idsAndVersions, idsAndVersionsSorted;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _context13.next = 2;
                return Promise.all(manyObjects.map(function () {
                  var _ref14 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee12(objects) {
                    var result;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee12$(_context12) {
                      while (1) {
                        switch (_context12.prev = _context12.next) {
                          case 0:
                            _context12.prev = 0;
                            _context12.next = 3;
                            return _this10.sources.merge(objects, true, false);

                          case 3:
                            result = _context12.sent;
                            return _context12.abrupt('return', result);

                          case 7:
                            _context12.prev = 7;
                            _context12.t0 = _context12['catch'](0);

                            if (!(_context12.t0 instanceof (_exceptions || _load_exceptions()).MergeConflict)) {
                              _context12.next = 11;
                              break;
                            }

                            return _context12.abrupt('return', _context12.t0);

                          case 11:
                            throw _context12.t0;

                          case 12:
                          case 'end':
                            return _context12.stop();
                        }
                      }
                    }, _callee12, _this10, [[0, 7]]);
                  }));

                  return function (_x16) {
                    return _ref14.apply(this, arguments);
                  };
                }()));

              case 2:
                mergeResults = _context13.sent;
                componentsWithConflicts = mergeResults.filter(function (result) {
                  return result instanceof (_exceptions || _load_exceptions()).MergeConflict;
                });

                if (!componentsWithConflicts.length) {
                  _context13.next = 8;
                  break;
                }

                idsAndVersions = componentsWithConflicts.map(function (c) {
                  return { id: c.id, versions: c.versions };
                });
                // sort to have a consistent error message

                idsAndVersionsSorted = (_ramda || _load_ramda()).default.sortBy((_ramda || _load_ramda()).default.prop('id'), idsAndVersions);
                throw new (_exceptions || _load_exceptions()).MergeConflictOnRemote(idsAndVersionsSorted);

              case 8:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function _mergeObjects(_x15) {
        return _ref13.apply(this, arguments);
      }

      return _mergeObjects;
    }()

    /**
     * @TODO there is no real difference between bare scope and a working directory scope - let's adjust terminology to avoid confusions in the future
     * saves a component into the objects directory of the remote scope, then, resolves its
     * dependencies, saves them as well. Finally runs the build process if needed on an isolated
     * environment.
     */

  }, {
    key: 'exportManyBareScope',
    value: function () {
      var _ref15 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee14(componentsObjects) {
        var _this11 = this;

        var manyObjects, manyCompVersions, versions, manyConsumerComponent, ids;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`exportManyBareScope: Going to save ${componentsObjects.length} components`);
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('exportManyBareScope', `exportManyBareScope: Going to save ${componentsObjects.length} components`);
                manyObjects = componentsObjects.map(function (componentObjects) {
                  return componentObjects.toObjects(_this11.objects);
                });
                _context14.next = 5;
                return this._mergeObjects(manyObjects);

              case 5:
                _context14.next = 7;
                return Promise.all(manyObjects.map(function (objects) {
                  return objects.component.toComponentVersion((_constants || _load_constants()).LATEST);
                }));

              case 7:
                manyCompVersions = _context14.sent;

                (_logger || _load_logger()).default.debug('exportManyBareScope: will try to importMany in case there are missing dependencies');
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('exportManyBareScope', 'exportManyBareScope: will try to importMany in case there are missing dependencies');
                _context14.next = 12;
                return this.importMany(manyCompVersions.map(function (compVersion) {
                  return compVersion.id;
                }), undefined, true, false);

              case 12:
                versions = _context14.sent;
                // resolve dependencies
                (_logger || _load_logger()).default.debug('exportManyBareScope: successfully ran importMany');
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('exportManyBareScope', 'exportManyBareScope: successfully ran importMany');
                _context14.next = 17;
                return this.objects.persist();

              case 17:
                _context14.next = 19;
                return Promise.all(versions.map(function (version) {
                  return version.toObjects(_this11.objects);
                }));

              case 19:
                _context14.next = 21;
                return Promise.all(manyCompVersions.map(function (compVersion) {
                  return compVersion.toConsumer(_this11.objects);
                }));

              case 21:
                manyConsumerComponent = _context14.sent;

                // await Promise.all(manyConsumerComponent.map(consumerComponent => index(consumerComponent, this.getPath())));
                ids = manyConsumerComponent.map(function (consumerComponent) {
                  return consumerComponent.id.toString();
                });
                _context14.next = 25;
                return Promise.all(manyConsumerComponent.map(function (consumerComponent) {
                  return (0, (_ciOps || _load_ciOps()).default)(consumerComponent, _this11.getPath());
                }));

              case 25:
                return _context14.abrupt('return', ids);

              case 26:
              case 'end':
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function exportManyBareScope(_x17) {
        return _ref15.apply(this, arguments);
      }

      return exportManyBareScope;
    }()
  }, {
    key: 'getExternalOnes',
    value: function getExternalOnes(ids, remotes) {
      var _this12 = this;

      var localFetch = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var context = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

      (_logger || _load_logger()).default.debug(`getExternalOnes, ids: ${ids.join(', ')}, localFetch: ${localFetch.toString()}`);
      (_analytics || _load_analytics()).Analytics.addBreadCrumb('getExternalOnes', `getExternalOnes, ids: ${(_analytics || _load_analytics()).Analytics.hashData(ids)}`);
      (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(Object.assign(context, { requestedBitIds: ids.map(function (id) {
          return id.toString();
        }) }));
      return this.sources.getMany(ids).then(function (defs) {
        var left = defs.filter(function (def) {
          if (!localFetch) return true;
          if (!def.component) return true;
          return false;
        });

        if (left.length === 0) {
          (_logger || _load_logger()).default.debug('getExternalOnes: no more ids left, all found locally, existing the method');
          (_analytics || _load_analytics()).Analytics.addBreadCrumb('getExternalOnes', 'getExternalOnes: no more ids left, all found locally, existing the method');
          return Promise.all(defs.map(function (def) {
            return def.component.toComponentVersion(def.id.version);
          }));
        }

        (_logger || _load_logger()).default.debug(`getExternalOnes: ${left.length} left. Fetching them from a remote`);
        (_analytics || _load_analytics()).Analytics.addBreadCrumb('getExternalOnes', `getExternalOnes: ${left.length} left. Fetching them from a remote`);
        return remotes.fetch(left.map(function (def) {
          return def.id;
        }), _this12, true, context).then(function (componentObjects) {
          return _this12.writeManyComponentsToModel(componentObjects);
        }).then(function () {
          return _this12.getExternalOnes(ids, remotes, true);
        });
      });
    }

    /**
     * recursive function.
     * if found locally, use them. Otherwise, fetch from remote and then, save into the model.
     */

  }, {
    key: 'getExternalMany',
    value: function getExternalMany(ids, remotes) {
      var localFetch = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      var _this13 = this;

      var persist = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
      var context = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};

      (_logger || _load_logger()).default.debug(`getExternalMany, planning on fetching from ${localFetch ? 'local' : 'remote'} scope. Ids: ${ids.join(', ')}`);
      (_analytics || _load_analytics()).Analytics.addBreadCrumb('getExternalMany', `getExternalMany, planning on fetching from ${localFetch ? 'local' : 'remote'} scope. Ids: ${(_analytics || _load_analytics()).Analytics.hashData(ids.join(', '))}`);
      (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(Object.assign(context, { requestedBitIds: ids.map(function (id) {
          return id.toString();
        }) }));
      return this.sources.getMany(ids).then(function (defs) {
        var left = defs.filter(function (def) {
          if (!localFetch) return true;
          if (!def.component) return true;
          return false;
        });

        if (left.length === 0) {
          (_logger || _load_logger()).default.debug('getExternalMany: no more ids left, all found locally, exiting the method');
          (_analytics || _load_analytics()).Analytics.addBreadCrumb('getExternalMany', 'getExternalMany: no more ids left, all found locally, exiting the method');
          // $FlowFixMe - there should be a component because there no defs without components left.
          return Promise.all(defs.map(function (def) {
            return def.component.toVersionDependencies(def.id.version, _this13, def.id.scope);
          }));
        }

        (_logger || _load_logger()).default.debug(`getExternalMany: ${left.length} left. Fetching them from a remote`);
        (_analytics || _load_analytics()).Analytics.addBreadCrumb('getExternalMany', `getExternalMany: ${left.length} left. Fetching them from a remote`);
        return remotes.fetch(left.map(function (def) {
          return def.id;
        }), _this13, undefined, context).then(function (componentObjects) {
          (_logger || _load_logger()).default.debug('getExternalMany: writing them to the model');
          (_analytics || _load_analytics()).Analytics.addBreadCrumb('getExternalMany', 'getExternalMany: writing them to the model');
          return _this13.writeManyComponentsToModel(componentObjects, persist);
        }).then(function () {
          return _this13.getExternalMany(ids, remotes);
        });
      });
    }

    /**
     * If the component is not in the local scope, fetch it from a remote and save into the local
     * scope. (objects directory).
     */

  }, {
    key: 'getExternal',
    value: function getExternal(_ref16) {
      var _this14 = this;

      var id = _ref16.id,
          remotes = _ref16.remotes,
          _ref16$localFetch = _ref16.localFetch,
          localFetch = _ref16$localFetch === undefined ? true : _ref16$localFetch,
          _ref16$context = _ref16.context,
          context = _ref16$context === undefined ? {} : _ref16$context;

      (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
      return this.sources.get(id).then(function (component) {
        if (component && localFetch) {
          return component.toVersionDependencies(id.version, _this14, id.scope);
        }

        return remotes.fetch([id], _this14, undefined, context).then(function (_ref17) {
          var _ref18 = _slicedToArray(_ref17, 1),
              componentObjects = _ref18[0];

          return _this14.writeComponentToModel(componentObjects);
        }).then(function () {
          return _this14.getExternal({ id, remotes, localFetch: true });
        });
      });
    }
  }, {
    key: 'getExternalOne',
    value: function getExternalOne(_ref19) {
      var _this15 = this;

      var id = _ref19.id,
          remotes = _ref19.remotes,
          _ref19$localFetch = _ref19.localFetch,
          localFetch = _ref19$localFetch === undefined ? true : _ref19$localFetch,
          _ref19$context = _ref19.context,
          context = _ref19$context === undefined ? {} : _ref19$context;

      return this.sources.get(id).then(function (component) {
        if (component && localFetch) return component.toComponentVersion(id.version);
        return remotes.fetch([id], _this15, true, context).then(function (_ref20) {
          var _ref21 = _slicedToArray(_ref20, 1),
              componentObjects = _ref21[0];

          return _this15.writeComponentToModel(componentObjects);
        }).then(function () {
          return _this15.getExternal({ id, remotes, localFetch: true });
        });
      });
    }
  }, {
    key: 'getObjects',
    value: function () {
      var _ref22 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee15(ids, withDevDependencies) {
        var _this16 = this;

        var versions;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                _context15.next = 2;
                return this.importMany(ids, withDevDependencies);

              case 2:
                versions = _context15.sent;
                return _context15.abrupt('return', Promise.all(versions.map(function (version) {
                  return version.toObjects(_this16.objects);
                })));

              case 4:
              case 'end':
                return _context15.stop();
            }
          }
        }, _callee15, this);
      }));

      function getObjects(_x23, _x24) {
        return _ref22.apply(this, arguments);
      }

      return getObjects;
    }()
  }, {
    key: 'getObject',
    value: function getObject(hash) {
      return new (_objects || _load_objects()).Ref(hash).load(this.objects);
    }
  }, {
    key: 'getRawObject',
    value: function getRawObject(hash) {
      return this.objects.loadRawObject(new (_objects || _load_objects()).Ref(hash));
    }

    /**
     * 1. Local objects, fetch from local. (done by this.sources.getMany method)
     * 2. Fetch flattened dependencies (done by toVersionDependencies method). If they're not locally, fetch from remote
     * and save them locally.
     * 3. External objects, fetch from a remote and save locally. (done by this.getExternalOnes method).
     */

  }, {
    key: 'importMany',
    value: function () {
      var _ref23 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee16(ids, withEnvironments) {
        var _this17 = this;

        var cache = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
        var persist = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;

        var idsWithoutNils, _splitWhen, _splitWhen2, externals, locals, localDefs, versionDeps, remotes, externalDeps;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.importMany: ${ids.join(', ')}`);
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('importMany', `scope.importMany: ${(_analytics || _load_analytics()).Analytics.hashData(ids)}`);
                idsWithoutNils = removeNils(ids);

                if (!(_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) {
                  _context16.next = 5;
                  break;
                }

                return _context16.abrupt('return', Promise.resolve([]));

              case 5:
                _splitWhen = (0, (_ramda2 || _load_ramda2()).splitWhen)(function (id) {
                  return id.isLocal(_this17.name);
                }, idsWithoutNils), _splitWhen2 = _slicedToArray(_splitWhen, 2), externals = _splitWhen2[0], locals = _splitWhen2[1];
                _context16.next = 8;
                return this.sources.getMany(locals);

              case 8:
                localDefs = _context16.sent;
                _context16.next = 11;
                return Promise.all(localDefs.map(function (def) {
                  if (!def.component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(def.id.toString());
                  return def.component.toVersionDependencies(def.id.version, _this17, def.id.scope, withEnvironments);
                }));

              case 11:
                versionDeps = _context16.sent;

                (_logger || _load_logger()).default.debug('scope.importMany: successfully fetched local components and their dependencies. Going to fetch externals');
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('importMany', 'scope.importMany: successfully fetched local components and their dependencies. Going to fetch externals');
                _context16.next = 16;
                return this.remotes();

              case 16:
                remotes = _context16.sent;
                _context16.next = 19;
                return this.getExternalMany(externals, remotes, cache, persist);

              case 19:
                externalDeps = _context16.sent;
                return _context16.abrupt('return', versionDeps.concat(externalDeps));

              case 21:
              case 'end':
                return _context16.stop();
            }
          }
        }, _callee16, this);
      }));

      function importMany(_x27, _x28) {
        return _ref23.apply(this, arguments);
      }

      return importMany;
    }()
  }, {
    key: 'importManyOnes',
    value: function () {
      var _ref24 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee17(ids) {
        var _this18 = this;

        var cache = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

        var idsWithoutNils, _splitBy, _splitBy2, externals, locals, localDefs, componentVersionArr, remotes, externalDeps;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.importManyOnes. Ids: ${ids.join(', ')}, cache: ${cache.toString()}`);
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('importManyOnes', `scope.importManyOnes. Ids: ${(_analytics || _load_analytics()).Analytics.hashData(ids)}`);

                idsWithoutNils = removeNils(ids);

                if (!(_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) {
                  _context17.next = 5;
                  break;
                }

                return _context17.abrupt('return', Promise.resolve([]));

              case 5:
                _splitBy = (0, (_utils || _load_utils()).splitBy)(idsWithoutNils, function (id) {
                  return id.isLocal(_this18.name);
                }), _splitBy2 = _slicedToArray(_splitBy, 2), externals = _splitBy2[0], locals = _splitBy2[1];
                _context17.next = 8;
                return this.sources.getMany(locals);

              case 8:
                localDefs = _context17.sent;
                _context17.next = 11;
                return Promise.all(localDefs.map(function (def) {
                  if (!def.component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(def.id.toString());
                  return def.component.toComponentVersion(def.id.version);
                }));

              case 11:
                componentVersionArr = _context17.sent;
                _context17.next = 14;
                return this.remotes();

              case 14:
                remotes = _context17.sent;
                _context17.next = 17;
                return this.getExternalOnes(externals, remotes, cache);

              case 17:
                externalDeps = _context17.sent;
                return _context17.abrupt('return', componentVersionArr.concat(externalDeps));

              case 19:
              case 'end':
                return _context17.stop();
            }
          }
        }, _callee17, this);
      }));

      function importManyOnes(_x30) {
        return _ref24.apply(this, arguments);
      }

      return importManyOnes;
    }()
  }, {
    key: 'manyOneObjects',
    value: function manyOneObjects(ids) {
      var _this19 = this;

      return this.importManyOnes(ids, false).then(function (componentVersions) {
        return Promise.all(componentVersions.map(function (version) {
          return version.toObjects(_this19.objects);
        }));
      });
    }
  }, {
    key: 'import',
    value: function _import(id) {
      var _this20 = this;

      if (!id.isLocal(this.name)) {
        return this.remotes().then(function (remotes) {
          return _this20.getExternal({ id, remotes, localFetch: true });
        });
      }

      return this.sources.get(id).then(function (component) {
        if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return component.toVersionDependencies(id.version, _this20, _this20.name);
      });
    }
  }, {
    key: 'get',
    value: function () {
      var _ref25 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee18(id) {
        var _this21 = this;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                return _context18.abrupt('return', this.import(id).then(function (versionDependencies) {
                  return versionDependencies.toConsumer(_this21.objects);
                }));

              case 1:
              case 'end':
                return _context18.stop();
            }
          }
        }, _callee18, this);
      }));

      function get(_x31) {
        return _ref25.apply(this, arguments);
      }

      return get;
    }()

    /**
     * return a component only when it's stored locally. Don't go to any remote server and don't throw an exception if the
     * component is not there.
     */

  }, {
    key: 'getFromLocalIfExist',
    value: function () {
      var _ref26 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee19(id) {
        var componentFromSources, versionDependencies;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee19$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                _context19.next = 2;
                return this.sources.get(id);

              case 2:
                componentFromSources = _context19.sent;

                if (componentFromSources) {
                  _context19.next = 5;
                  break;
                }

                return _context19.abrupt('return', null);

              case 5:
                _context19.next = 7;
                return componentFromSources.toVersionDependencies(id.version, this, this.name);

              case 7:
                versionDependencies = _context19.sent;
                return _context19.abrupt('return', versionDependencies.toConsumer(this.objects));

              case 9:
              case 'end':
                return _context19.stop();
            }
          }
        }, _callee19, this);
      }));

      function getFromLocalIfExist(_x32) {
        return _ref26.apply(this, arguments);
      }

      return getFromLocalIfExist;
    }()
  }, {
    key: 'getModelComponentIfExist',
    value: function () {
      var _ref27 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee20(id) {
        return (_regenerator || _load_regenerator()).default.wrap(function _callee20$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                return _context20.abrupt('return', this.sources.get(id));

              case 1:
              case 'end':
                return _context20.stop();
            }
          }
        }, _callee20, this);
      }));

      function getModelComponentIfExist(_x33) {
        return _ref27.apply(this, arguments);
      }

      return getModelComponentIfExist;
    }()

    /**
     * get multiple components from a scope, if not found in the local scope, fetch from a remote
     * scope. Then, write them to the local scope.
     */

  }, {
    key: 'getMany',
    value: function getMany(ids) {
      var _this22 = this;

      var cache = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      (_logger || _load_logger()).default.debug(`scope.getMany, Ids: ${ids.join(', ')}`);
      (_analytics || _load_analytics()).Analytics.addBreadCrumb('getMany', `scope.getMany, Ids: ${(_analytics || _load_analytics()).Analytics.hashData(ids)}`);

      var idsWithoutNils = removeNils(ids);
      if ((_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) return Promise.resolve([]);
      return this.importMany(idsWithoutNils, false, cache).then(function (versionDependenciesArr) {
        return Promise.all(versionDependenciesArr.map(function (versionDependencies) {
          return versionDependencies.toConsumer(_this22.objects);
        }));
      });
    }

    // todo: improve performance by finding all versions needed and fetching them in one request from the server
    // currently it goes to the server twice. First, it asks for the last version of each id, and then it goes again to
    // ask for the older versions.

  }, {
    key: 'getManyWithAllVersions',
    value: function () {
      var _ref28 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee21(ids) {
        var _this23 = this;

        var cache = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var idsWithoutNils, versionDependenciesArr, allVersionsP;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee21$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.getManyWithAllVersions, Ids: ${ids.join(', ')}`);
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('getManyWithAllVersions', `scope.getManyWithAllVersions, Ids: ${(_analytics || _load_analytics()).Analytics.hashData(ids)}`);
                idsWithoutNils = removeNils(ids);

                if (!(_ramda || _load_ramda()).default.isEmpty(idsWithoutNils)) {
                  _context21.next = 5;
                  break;
                }

                return _context21.abrupt('return', Promise.resolve([]));

              case 5:
                _context21.next = 7;
                return this.importMany(idsWithoutNils, false, cache);

              case 7:
                versionDependenciesArr = _context21.sent;
                allVersionsP = versionDependenciesArr.map(function (versionDependencies) {
                  var versions = versionDependencies.component.component.listVersions();
                  var idsWithAllVersions = versions.map(function (version) {
                    if (version === versionDependencies.component.version) return null; // imported already
                    var versionId = versionDependencies.component.id;
                    versionId.version = version;
                    return versionId;
                  });
                  return _this23.importManyOnes(idsWithAllVersions);
                });
                _context21.next = 11;
                return Promise.all(allVersionsP);

              case 11:
                return _context21.abrupt('return', Promise.all(versionDependenciesArr.map(function (versionDependencies) {
                  return versionDependencies.toConsumer(_this23.objects);
                })));

              case 12:
              case 'end':
                return _context21.stop();
            }
          }
        }, _callee21, this);
      }));

      function getManyWithAllVersions(_x36) {
        return _ref28.apply(this, arguments);
      }

      return getManyWithAllVersions;
    }()
  }, {
    key: 'deprecateSingle',
    value: function () {
      var _ref29 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee22(bitId) {
        var component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee22$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                _context22.next = 2;
                return this.sources.get(bitId);

              case 2:
                component = _context22.sent;

                component.deprecated = true;
                this.objects.add(component);
                _context22.next = 7;
                return this.objects.persist();

              case 7:
                return _context22.abrupt('return', bitId.toStringWithoutVersion());

              case 8:
              case 'end':
                return _context22.stop();
            }
          }
        }, _callee22, this);
      }));

      function deprecateSingle(_x37) {
        return _ref29.apply(this, arguments);
      }

      return deprecateSingle;
    }()

    /**
     * Remove components from scope
     * @force Boolean  - remove component from scope even if other components use it
     */

  }, {
    key: 'removeMany',
    value: function () {
      var _ref30 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee23(bitIds, force) {
        var removeSameOrigin = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
        var consumer = arguments[3];
        var removeComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee23$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.removeMany ${bitIds} with force flag: ${force.toString()}`);
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('removeMany', `scope.removeMany ${(_analytics || _load_analytics()).Analytics.hashData(bitIds)} with force flag: ${force.toString()}`);
                removeComponents = new (_removeModelComponents || _load_removeModelComponents()).default(this, bitIds, force, removeSameOrigin, consumer);
                return _context23.abrupt('return', removeComponents.remove());

              case 4:
              case 'end':
                return _context23.stop();
            }
          }
        }, _callee23, this);
      }));

      function removeMany(_x39, _x40) {
        return _ref30.apply(this, arguments);
      }

      return removeMany;
    }()

    /**
     * findDependentBits
     * foreach component in array find the componnet that uses that component
     */

  }, {
    key: 'findDependentBits',
    value: function () {
      var _ref31 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee26(bitIds) {
        var _this24 = this;

        var returnResultsWithVersion = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var allComponents, allComponentVersions, allScopeComponents, dependentBits;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee26$(_context26) {
          while (1) {
            switch (_context26.prev = _context26.next) {
              case 0:
                _context26.next = 2;
                return this.objects.listComponents(false);

              case 2:
                allComponents = _context26.sent;
                _context26.next = 5;
                return Promise.all(allComponents.map(function () {
                  var _ref32 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee25(component) {
                    var loadedVersions;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee25$(_context25) {
                      while (1) {
                        switch (_context25.prev = _context25.next) {
                          case 0:
                            _context25.next = 2;
                            return Promise.all(Object.keys(component.versions).map(function () {
                              var _ref33 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee24(version) {
                                var componentVersion;
                                return (_regenerator || _load_regenerator()).default.wrap(function _callee24$(_context24) {
                                  while (1) {
                                    switch (_context24.prev = _context24.next) {
                                      case 0:
                                        _context24.next = 2;
                                        return component.loadVersion(version, _this24.objects);

                                      case 2:
                                        componentVersion = _context24.sent;

                                        if (componentVersion) {
                                          _context24.next = 5;
                                          break;
                                        }

                                        return _context24.abrupt('return');

                                      case 5:
                                        componentVersion.id = (_bitId || _load_bitId()).BitId.parse(component.id());
                                        return _context24.abrupt('return', componentVersion);

                                      case 7:
                                      case 'end':
                                        return _context24.stop();
                                    }
                                  }
                                }, _callee24, _this24);
                              }));

                              return function (_x44) {
                                return _ref33.apply(this, arguments);
                              };
                            }()));

                          case 2:
                            loadedVersions = _context25.sent;
                            return _context25.abrupt('return', loadedVersions.filter(function (x) {
                              return x;
                            }));

                          case 4:
                          case 'end':
                            return _context25.stop();
                        }
                      }
                    }, _callee25, _this24);
                  }));

                  return function (_x43) {
                    return _ref32.apply(this, arguments);
                  };
                }()));

              case 5:
                allComponentVersions = _context26.sent;
                allScopeComponents = (_ramda || _load_ramda()).default.flatten(allComponentVersions);
                dependentBits = {};

                bitIds.forEach(function (bitId) {
                  var dependencies = [];
                  allScopeComponents.forEach(function (scopeComponents) {
                    scopeComponents.flattenedDependencies.forEach(function (flattenedDependence) {
                      if (flattenedDependence.toStringWithoutVersion() === bitId.toStringWithoutVersion()) {
                        returnResultsWithVersion ? dependencies.push(scopeComponents.id.toString()) : dependencies.push(scopeComponents.id.toStringWithoutVersion());
                      }
                    });
                  });

                  if (!(_ramda || _load_ramda()).default.isEmpty(dependencies)) dependentBits[bitId.toStringWithoutVersion()] = (_ramda || _load_ramda()).default.uniq(dependencies);
                });
                return _context26.abrupt('return', Promise.resolve(dependentBits));

              case 10:
              case 'end':
                return _context26.stop();
            }
          }
        }, _callee26, this);
      }));

      function findDependentBits(_x42) {
        return _ref31.apply(this, arguments);
      }

      return findDependentBits;
    }()

    /**
     * split bit array to found and missing components (incase user misspelled id)
     */

  }, {
    key: 'filterFoundAndMissingComponents',
    value: function () {
      var _ref34 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee28(bitIds) {
        var _this25 = this;

        var missingComponents, foundComponents, resultP;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee28$(_context28) {
          while (1) {
            switch (_context28.prev = _context28.next) {
              case 0:
                missingComponents = new (_bitId || _load_bitId()).BitIds();
                foundComponents = new (_bitId || _load_bitId()).BitIds();
                resultP = bitIds.map(function () {
                  var _ref35 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee27(id) {
                    var component;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee27$(_context27) {
                      while (1) {
                        switch (_context27.prev = _context27.next) {
                          case 0:
                            _context27.next = 2;
                            return _this25.sources.get(id);

                          case 2:
                            component = _context27.sent;

                            if (!component) missingComponents.push(id);else foundComponents.push(id);

                          case 4:
                          case 'end':
                            return _context27.stop();
                        }
                      }
                    }, _callee27, _this25);
                  }));

                  return function (_x46) {
                    return _ref35.apply(this, arguments);
                  };
                }());
                _context28.next = 5;
                return Promise.all(resultP);

              case 5:
                return _context28.abrupt('return', Promise.resolve({ missingComponents, foundComponents }));

              case 6:
              case 'end':
                return _context28.stop();
            }
          }
        }, _callee28, this);
      }));

      function filterFoundAndMissingComponents(_x45) {
        return _ref34.apply(this, arguments);
      }

      return filterFoundAndMissingComponents;
    }()

    /**
     * deprecate components from scope
     */

  }, {
    key: 'deprecateMany',
    value: function () {
      var _ref36 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee30(bitIds) {
        var _this26 = this;

        var _ref37, missingComponents, foundComponents, deprecateComponents, deprecatedComponents, missingComponentsStrings;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee30$(_context30) {
          while (1) {
            switch (_context30.prev = _context30.next) {
              case 0:
                _context30.next = 2;
                return this.filterFoundAndMissingComponents(bitIds);

              case 2:
                _ref37 = _context30.sent;
                missingComponents = _ref37.missingComponents;
                foundComponents = _ref37.foundComponents;

                deprecateComponents = function deprecateComponents() {
                  return foundComponents.map(function () {
                    var _ref38 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee29(bitId) {
                      return (_regenerator || _load_regenerator()).default.wrap(function _callee29$(_context29) {
                        while (1) {
                          switch (_context29.prev = _context29.next) {
                            case 0:
                              return _context29.abrupt('return', _this26.deprecateSingle(bitId));

                            case 1:
                            case 'end':
                              return _context29.stop();
                          }
                        }
                      }, _callee29, _this26);
                    }));

                    return function (_x48) {
                      return _ref38.apply(this, arguments);
                    };
                  }());
                };

                _context30.next = 8;
                return Promise.all(deprecateComponents());

              case 8:
                deprecatedComponents = _context30.sent;
                missingComponentsStrings = missingComponents.map(function (id) {
                  return id.toStringWithoutVersion();
                });
                return _context30.abrupt('return', { bitIds: deprecatedComponents, missingComponents: missingComponentsStrings });

              case 11:
              case 'end':
                return _context30.stop();
            }
          }
        }, _callee30, this);
      }));

      function deprecateMany(_x47) {
        return _ref36.apply(this, arguments);
      }

      return deprecateMany;
    }()
  }, {
    key: 'loadRemoteComponent',
    value: function loadRemoteComponent(id) {
      var _this27 = this;

      return this.getComponentVersion(id).then(function (component) {
        if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return component.toConsumer(_this27.objects);
      });
    }
  }, {
    key: 'loadComponent',
    value: function loadComponent(id) {
      var localOnly = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      (_logger || _load_logger()).default.debug(`scope.loadComponent, id: ${id}`);
      (_analytics || _load_analytics()).Analytics.addBreadCrumb('loadComponent', `scope.loadComponent, id: ${id.toString()}`);

      if (localOnly && !id.isLocal(this.name)) {
        throw new (_generalError || _load_generalError()).default('cannot load bit from remote scope, please import first');
      }
      return this.loadRemoteComponent(id);
    }

    /**
     * load components from the model and return them as ComponentVersion array.
     * if a component is not available locally, it'll just ignore it without throwing any error.
     */

  }, {
    key: 'loadLocalComponents',
    value: function () {
      var _ref39 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee31(ids) {
        var componentsObjects, components;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee31$(_context31) {
          while (1) {
            switch (_context31.prev = _context31.next) {
              case 0:
                _context31.next = 2;
                return this.sources.getMany(ids);

              case 2:
                componentsObjects = _context31.sent;
                components = componentsObjects.map(function (componentObject) {
                  var component = componentObject.component;
                  if (!component) return null;
                  var version = componentObject.id.hasVersion() ? componentObject.id.version : component.latest();
                  return component.toComponentVersion(version);
                });
                return _context31.abrupt('return', removeNils(components));

              case 5:
              case 'end':
                return _context31.stop();
            }
          }
        }, _callee31, this);
      }));

      function loadLocalComponents(_x50) {
        return _ref39.apply(this, arguments);
      }

      return loadLocalComponents;
    }()
  }, {
    key: 'loadComponentLogs',
    value: function loadComponentLogs(id) {
      var _this28 = this;

      return this.sources.get(id).then(function (componentModel) {
        if (!componentModel) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return componentModel.collectLogs(_this28.objects);
      });
    }
  }, {
    key: 'loadAllVersions',
    value: function loadAllVersions(id) {
      var _this29 = this;

      return this.sources.get(id).then(function (componentModel) {
        if (!componentModel) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return componentModel.collectVersions(_this29.objects);
      });
    }
  }, {
    key: 'getComponentVersion',
    value: function () {
      var _ref40 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee32(id) {
        var _this30 = this;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee32$(_context32) {
          while (1) {
            switch (_context32.prev = _context32.next) {
              case 0:
                if (id.isLocal(this.name)) {
                  _context32.next = 2;
                  break;
                }

                return _context32.abrupt('return', this.remotes().then(function (remotes) {
                  return _this30.getExternalOne({ id, remotes, localFetch: true });
                }));

              case 2:
                return _context32.abrupt('return', this.sources.get(id).then(function (component) {
                  if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
                  return component.toComponentVersion(id.version);
                }));

              case 3:
              case 'end':
                return _context32.stop();
            }
          }
        }, _callee32, this);
      }));

      function getComponentVersion(_x51) {
        return _ref40.apply(this, arguments);
      }

      return getComponentVersion;
    }()

    /**
     * Get ComponentModel instance per bit-id. The id can be either with or without a scope-name.
     * In case the component is saved in the model only with the scope (imported), it loads all
     * components and search for it.
     * It throws an error if the component wasn't found.
     */

  }, {
    key: 'getComponentModel',
    value: function () {
      var _ref41 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee33(id) {
        var component, components, foundComponent;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee33$(_context33) {
          while (1) {
            switch (_context33.prev = _context33.next) {
              case 0:
                _context33.next = 2;
                return this.sources.get(id);

              case 2:
                component = _context33.sent;

                if (!component) {
                  _context33.next = 5;
                  break;
                }

                return _context33.abrupt('return', component);

              case 5:
                if (id.scope) {
                  _context33.next = 12;
                  break;
                }

                _context33.next = 8;
                return this.objects.listComponents(false);

              case 8:
                components = _context33.sent;
                // don't fetch Symlinks
                foundComponent = components.filter(function (c) {
                  return c.toBitId().toStringWithoutScopeAndVersion() === id.toStringWithoutVersion();
                });
                // $FlowFixMe

                if (!foundComponent.length) {
                  _context33.next = 12;
                  break;
                }

                return _context33.abrupt('return', (0, (_utils || _load_utils()).first)(foundComponent));

              case 12:
                throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());

              case 13:
              case 'end':
                return _context33.stop();
            }
          }
        }, _callee33, this);
      }));

      function getComponentModel(_x52) {
        return _ref41.apply(this, arguments);
      }

      return getComponentModel;
    }()
  }, {
    key: 'getConsumerComponent',
    value: function () {
      var _ref42 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee34(id) {
        var componentModel;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee34$(_context34) {
          while (1) {
            switch (_context34.prev = _context34.next) {
              case 0:
                _context34.next = 2;
                return this.getComponentModel(id);

              case 2:
                componentModel = _context34.sent;
                return _context34.abrupt('return', componentModel.toConsumerComponent(id.version, this.name, this.objects));

              case 4:
              case 'end':
                return _context34.stop();
            }
          }
        }, _callee34, this);
      }));

      function getConsumerComponent(_x53) {
        return _ref42.apply(this, arguments);
      }

      return getConsumerComponent;
    }()

    /**
     * Creates a symlink object with the local-scope which links to the real-object of the remote-scope
     * This way, local components that have dependencies to the exported component won't break.
     */

  }, {
    key: 'createSymlink',
    value: function createSymlink(id, remote) {
      var symlink = new (_models || _load_models()).Symlink({
        scope: id.scope,
        name: id.name,
        box: id.box,
        realScope: remote
      });
      return this.objects.add(symlink);
    }
  }, {
    key: 'exportMany',
    value: function () {
      var _ref43 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee36(ids, remoteName) {
        var _this31 = this;

        var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        var eject = arguments[3];
        var remotes, remote, componentIds, componentObjectsP, componentObjects, componentsAndObjects, manyObjectsP, manyObjects, exportedIds, idsWithRemoteScope;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee36$(_context36) {
          while (1) {
            switch (_context36.prev = _context36.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`exportMany, ids: ${ids.join(', ')}`);
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('exportMany', `exportMany, ids: ${(_analytics || _load_analytics()).Analytics.hashData(ids.join(', '))}`);

                _context36.next = 4;
                return this.remotes();

              case 4:
                remotes = _context36.sent;

                if (!(eject && !remotes.isHub(remoteName))) {
                  _context36.next = 7;
                  break;
                }

                return _context36.abrupt('return', Promise.reject('--eject flag is relevant only when the remote is a hub'));

              case 7:
                _context36.next = 9;
                return remotes.resolve(remoteName, this);

              case 9:
                remote = _context36.sent;
                componentIds = ids.map(function (id) {
                  return (_bitId || _load_bitId()).BitId.parse(id);
                });
                componentObjectsP = componentIds.map(function (id) {
                  return _this31.sources.getObjects(id);
                });
                _context36.next = 14;
                return Promise.all(componentObjectsP);

              case 14:
                componentObjects = _context36.sent;
                componentsAndObjects = [];

                (0, (_enrichContextFromGlobal || _load_enrichContextFromGlobal()).default)(context);
                manyObjectsP = componentObjects.map(function () {
                  var _ref44 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee35(componentObject) {
                    var componentAndObject, componentBuffer, objectsBuffer;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee35$(_context35) {
                      while (1) {
                        switch (_context35.prev = _context35.next) {
                          case 0:
                            componentAndObject = componentObject.toObjects(_this31.objects);

                            componentAndObject.component.clearStateData();
                            _this31._convertNonScopeToCorrectScope(componentAndObject, remoteName);
                            componentsAndObjects.push(componentAndObject);
                            _context35.next = 6;
                            return componentAndObject.component.compress();

                          case 6:
                            componentBuffer = _context35.sent;
                            _context35.next = 9;
                            return Promise.all(componentAndObject.objects.map(function (obj) {
                              return obj.compress();
                            }));

                          case 9:
                            objectsBuffer = _context35.sent;
                            return _context35.abrupt('return', new (_componentObjects || _load_componentObjects()).default(componentBuffer, objectsBuffer));

                          case 11:
                          case 'end':
                            return _context35.stop();
                        }
                      }
                    }, _callee35, _this31);
                  }));

                  return function (_x57) {
                    return _ref44.apply(this, arguments);
                  };
                }());
                _context36.next = 20;
                return Promise.all(manyObjectsP);

              case 20:
                manyObjects = _context36.sent;
                exportedIds = void 0;
                _context36.prev = 22;
                _context36.next = 25;
                return remote.pushMany(manyObjects, context);

              case 25:
                exportedIds = _context36.sent;

                (_logger || _load_logger()).default.debug('exportMany: successfully pushed all ids to the bare-scope, going to save them back to local scope');
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('exportMany', 'exportMany: successfully pushed all ids to the bare-scope, going to save them back to local scope');
                _context36.next = 34;
                break;

              case 30:
                _context36.prev = 30;
                _context36.t0 = _context36['catch'](22);

                (_logger || _load_logger()).default.warn('exportMany: failed pushing ids to the bare-scope');
                return _context36.abrupt('return', Promise.reject(_context36.t0));

              case 34:
                _context36.next = 36;
                return Promise.all(componentIds.map(function (id) {
                  return _this31.clean(id);
                }));

              case 36:
                componentIds.map(function (id) {
                  return _this31.createSymlink(id, remoteName);
                });
                idsWithRemoteScope = exportedIds.map(function (id) {
                  return (_bitId || _load_bitId()).BitId.parse(id);
                });
                _context36.next = 40;
                return Promise.all(componentsAndObjects.map(function (componentObject) {
                  return _this31.sources.merge(componentObject);
                }));

              case 40:
                _context36.next = 42;
                return this.objects.persist();

              case 42:
                return _context36.abrupt('return', idsWithRemoteScope);

              case 43:
              case 'end':
                return _context36.stop();
            }
          }
        }, _callee36, this, [[22, 30]]);
      }));

      function exportMany(_x55, _x56) {
        return _ref43.apply(this, arguments);
      }

      return exportMany;
    }()
  }, {
    key: 'ensureDir',
    value: function ensureDir() {
      var _this32 = this;

      (_fsExtra || _load_fsExtra()).default.ensureDirSync(this.getComponentsPath());
      return this.tmp.ensureDir().then(function () {
        return _this32.scopeJson.write(_this32.getPath());
      }).then(function () {
        return _this32.objects.ensureDir();
      }).then(function () {
        return _this32;
      });
    }
  }, {
    key: 'clean',
    value: function clean(bitId) {
      return this.sources.clean(bitId);
    }

    /**
     * sync method that loads the environment/(path to environment component)
     */

  }, {
    key: 'isEnvironmentInstalled',
    value: function isEnvironmentInstalled(bitId) {
      (_logger || _load_logger()).default.debug(`scope.isEnvironmentInstalled, id: ${bitId}`);
      (_analytics || _load_analytics()).Analytics.addBreadCrumb('isEnvironmentInstalled', `scope.isEnvironmentInstalled, id: ${(_analytics || _load_analytics()).Analytics.hashData(bitId.toString())}`);
      if (!bitId) throw new Error('scope.isEnvironmentInstalled a required argument "bitId" is missing');
      var notFound = function notFound() {
        (_logger || _load_logger()).default.debug(`Unable to find an env component ${bitId.toString()}`);
        (_analytics || _load_analytics()).Analytics.addBreadCrumb('isEnvironmentInstalled', `Unable to find an env component ${(_analytics || _load_analytics()).Analytics.hashData(bitId.toString())}`);

        return false;
      };

      var envPath = void 0;
      try {
        envPath = (0, (_componentResolver || _load_componentResolver()).default)(bitId.toString(), null, this.getPath());
      } catch (err) {
        return notFound();
      }
      if (!(_environment || _load_environment()).default.isEnvironmentInstalled(envPath)) return notFound();

      (_logger || _load_logger()).default.debug(`found an environment file at ${envPath}`);
      (_analytics || _load_analytics()).Analytics.addBreadCrumb('isEnvironmentInstalled', `found an environment file at ${(_analytics || _load_analytics()).Analytics.hashData(envPath)}`);
      return true;
    }

    // TODO: Change name since it also used to install extension

  }, {
    key: 'installEnvironment',
    value: function () {
      var _ref46 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee38(_ref45) {
        var _this33 = this;

        var ids = _ref45.ids,
            dependentId = _ref45.dependentId,
            verbose = _ref45.verbose,
            dontPrintEnvMsg = _ref45.dontPrintEnvMsg;
        var componentsDir, isolateOpts, idsWithoutNils, predicate, uniqIds, nonExistingEnvsIds, importEnv;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee38$(_context38) {
          while (1) {
            switch (_context38.prev = _context38.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`scope.installEnvironment, ids: ${ids.map(function (id) {
                  return id.componentId;
                }).join(', ')}`);
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('installEnvironment', `scope.installEnvironment, ids: ${(_analytics || _load_analytics()).Analytics.hashData(ids)}`);
                componentsDir = this.getComponentsPath();
                isolateOpts = {
                  writeBitDependencies: false,
                  installPackages: true,
                  noPackageJson: false,
                  dist: true,
                  conf: true,
                  override: false,
                  verbose,
                  silentPackageManagerResult: true
                };
                idsWithoutNils = removeNils(ids);

                predicate = function predicate(id) {
                  return id.componentId.toString();
                }; // TODO: should be moved to BitId class


                uniqIds = (_ramda || _load_ramda()).default.uniqBy(predicate)(idsWithoutNils);
                nonExistingEnvsIds = uniqIds.filter(function (id) {
                  return !_this33.isEnvironmentInstalled(id.componentId);
                });

                if (nonExistingEnvsIds.length) {
                  _context38.next = 12;
                  break;
                }

                (_logger || _load_logger()).default.debug('scope.installEnvironment, all environment were successfully loaded, nothing to install');
                (_analytics || _load_analytics()).Analytics.addBreadCrumb('installEnvironment', 'scope.installEnvironment, all environment were successfully loaded, nothing to install');
                return _context38.abrupt('return', []);

              case 12:
                importEnv = function () {
                  var _ref47 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee37(id) {
                    var concreteId, concreteIds, dir, env, isolatedComponent;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee37$(_context37) {
                      while (1) {
                        switch (_context37.prev = _context37.next) {
                          case 0:
                            concreteId = id.componentId;

                            if (!id.componentId.getVersion().latest) {
                              _context37.next = 6;
                              break;
                            }

                            _context37.next = 4;
                            return _this33.fetchRemoteVersions([id.componentId]);

                          case 4:
                            concreteIds = _context37.sent;

                            concreteId = concreteIds[0];

                          case 6:
                            (_logger || _load_logger()).default.debug(`scope.installEnvironment.importEnv, id: ${concreteId.toString()}`);

                            dir = (_path || _load_path()).join(componentsDir, Scope.getComponentRelativePath(concreteId));
                            env = new (_environment || _load_environment()).default(_this33, dir);
                            // Destroying environment to make sure there is no left over

                            env.destroyIfExist();
                            _context37.next = 12;
                            return env.create();

                          case 12:
                            _context37.prev = 12;
                            _context37.next = 15;
                            return env.isolateComponent(concreteId, isolateOpts);

                          case 15:
                            isolatedComponent = _context37.sent;

                            if (!dontPrintEnvMsg) {
                              console.log((_chalk || _load_chalk()).default.bold.green(`successfully installed the ${concreteId.toString()} ${id.type}`));
                            }
                            return _context37.abrupt('return', isolatedComponent);

                          case 20:
                            _context37.prev = 20;
                            _context37.t0 = _context37['catch'](12);

                            if (_context37.t0 instanceof (_exceptions || _load_exceptions()).ComponentNotFound) {
                              _context37.t0.dependentId = dependentId.toString();
                            }
                            throw _context37.t0;

                          case 24:
                          case 'end':
                            return _context37.stop();
                        }
                      }
                    }, _callee37, _this33, [[12, 20]]);
                  }));

                  return function importEnv(_x59) {
                    return _ref47.apply(this, arguments);
                  };
                }();

                return _context38.abrupt('return', (0, (_pMapSeries || _load_pMapSeries()).default)(nonExistingEnvsIds, importEnv));

              case 14:
              case 'end':
                return _context38.stop();
            }
          }
        }, _callee38, this);
      }));

      function installEnvironment(_x58) {
        return _ref46.apply(this, arguments);
      }

      return installEnvironment;
    }()
  }, {
    key: 'bumpDependenciesVersions',
    value: function () {
      var _ref48 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee40(componentsToUpdate, committedComponents, persist) {
        var _this34 = this;

        var componentsObjects, componentsToUpdateP, updatedComponentsAll, updatedComponents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee40$(_context40) {
          while (1) {
            switch (_context40.prev = _context40.next) {
              case 0:
                _context40.next = 2;
                return this.sources.getMany(componentsToUpdate);

              case 2:
                componentsObjects = _context40.sent;
                componentsToUpdateP = componentsObjects.map(function () {
                  var _ref49 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee39(componentObjects) {
                    var component, loadedVersion, pendingUpdate, _message;

                    return (_regenerator || _load_regenerator()).default.wrap(function _callee39$(_context39) {
                      while (1) {
                        switch (_context39.prev = _context39.next) {
                          case 0:
                            component = componentObjects.component;

                            if (component) {
                              _context39.next = 3;
                              break;
                            }

                            return _context39.abrupt('return', null);

                          case 3:
                            _context39.next = 5;
                            return component.loadVersion(componentObjects.id.getVersion().toString(), _this34.objects);

                          case 5:
                            loadedVersion = _context39.sent;
                            pendingUpdate = false;

                            loadedVersion.getAllDependencies().forEach(function (dependency) {
                              var committedComponentId = committedComponents.find(function (committedComponent) {
                                return committedComponent.toStringWithoutVersion() === dependency.id.toStringWithoutVersion();
                              });

                              if (!committedComponentId) return;
                              if ((_semver || _load_semver()).default.gt(committedComponentId.version, dependency.id.version)) {
                                dependency.id.version = committedComponentId.version;
                                var flattenDependencyToUpdate = loadedVersion.flattenedDependencies.find(function (flattenDependency) {
                                  return flattenDependency.toStringWithoutVersion() === dependency.id.toStringWithoutVersion();
                                });
                                flattenDependencyToUpdate.version = committedComponentId.version;
                                pendingUpdate = true;
                                // if !persist, we only check whether a modified component may cause auto-tagging
                                // since it's only modified on the file-system, its version might be the same as the version stored in its
                                // dependents. That's why in this case even equal means pendingUpdate
                              } else if (!persist && (_semver || _load_semver()).default.eq(committedComponentId.version, dependency.id.version)) {
                                pendingUpdate = true;
                              }
                            });

                            if (!pendingUpdate) {
                              _context39.next = 13;
                              break;
                            }

                            if (persist) {
                              _context39.next = 11;
                              break;
                            }

                            return _context39.abrupt('return', component);

                          case 11:
                            _message = 'bump dependencies versions';
                            return _context39.abrupt('return', _this34.sources.putAdditionalVersion(component, loadedVersion, _message));

                          case 13:
                            return _context39.abrupt('return', null);

                          case 14:
                          case 'end':
                            return _context39.stop();
                        }
                      }
                    }, _callee39, _this34);
                  }));

                  return function (_x63) {
                    return _ref49.apply(this, arguments);
                  };
                }());
                _context40.next = 6;
                return Promise.all(componentsToUpdateP);

              case 6:
                updatedComponentsAll = _context40.sent;
                updatedComponents = removeNils(updatedComponentsAll);
                return _context40.abrupt('return', updatedComponents);

              case 9:
              case 'end':
                return _context40.stop();
            }
          }
        }, _callee40, this);
      }));

      function bumpDependenciesVersions(_x60, _x61, _x62) {
        return _ref48.apply(this, arguments);
      }

      return bumpDependenciesVersions;
    }()

    /**
     * find the components in componentsPool which one of their dependencies include in potentialDependencies
     */

  }, {
    key: 'findDirectDependentComponents',
    value: function () {
      var _ref50 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee42(componentsPool, potentialDependencies) {
        var _this35 = this;

        var componentsVersions, potentialDependenciesWithoutVersions, dependentsP, dependents;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee42$(_context42) {
          while (1) {
            switch (_context42.prev = _context42.next) {
              case 0:
                _context42.next = 2;
                return this.loadLocalComponents(componentsPool);

              case 2:
                componentsVersions = _context42.sent;
                potentialDependenciesWithoutVersions = potentialDependencies.map(function (id) {
                  return id.toStringWithoutVersion();
                });
                dependentsP = componentsVersions.map(function () {
                  var _ref51 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee41(componentVersion) {
                    var component, found;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee41$(_context41) {
                      while (1) {
                        switch (_context41.prev = _context41.next) {
                          case 0:
                            _context41.next = 2;
                            return componentVersion.getVersion(_this35.objects);

                          case 2:
                            component = _context41.sent;
                            found = component.getAllDependencies().find(function (dependency) {
                              return potentialDependenciesWithoutVersions.includes(dependency.id.toStringWithoutVersion());
                            });
                            return _context41.abrupt('return', found ? componentVersion.toConsumer(_this35.objects) : null);

                          case 5:
                          case 'end':
                            return _context41.stop();
                        }
                      }
                    }, _callee41, _this35);
                  }));

                  return function (_x66) {
                    return _ref51.apply(this, arguments);
                  };
                }());
                _context42.next = 7;
                return Promise.all(dependentsP);

              case 7:
                dependents = _context42.sent;
                return _context42.abrupt('return', removeNils(dependents));

              case 9:
              case 'end':
                return _context42.stop();
            }
          }
        }, _callee42, this);
      }));

      function findDirectDependentComponents(_x64, _x65) {
        return _ref50.apply(this, arguments);
      }

      return findDirectDependentComponents;
    }()
  }, {
    key: 'runComponentSpecs',
    value: function () {
      var _ref53 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee43(_ref52) {
        var bitId = _ref52.bitId,
            consumer = _ref52.consumer,
            save = _ref52.save,
            verbose = _ref52.verbose,
            isolated = _ref52.isolated,
            directory = _ref52.directory,
            keep = _ref52.keep;
        var component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee43$(_context43) {
          while (1) {
            switch (_context43.prev = _context43.next) {
              case 0:
                if (bitId.isLocal(this.name)) {
                  _context43.next = 2;
                  break;
                }

                throw new (_generalError || _load_generalError()).default('cannot run specs on remote component');

              case 2:
                _context43.next = 4;
                return this.loadComponent(bitId);

              case 4:
                component = _context43.sent;
                return _context43.abrupt('return', component.runSpecs({
                  scope: this,
                  consumer,
                  save,
                  verbose,
                  isolated,
                  directory,
                  keep
                }));

              case 6:
              case 'end':
                return _context43.stop();
            }
          }
        }, _callee43, this);
      }));

      function runComponentSpecs(_x67) {
        return _ref53.apply(this, arguments);
      }

      return runComponentSpecs;
    }()
  }, {
    key: 'build',
    value: function () {
      var _ref55 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee44(_ref54) {
        var bitId = _ref54.bitId,
            save = _ref54.save,
            consumer = _ref54.consumer,
            verbose = _ref54.verbose,
            directory = _ref54.directory,
            keep = _ref54.keep;
        var component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee44$(_context44) {
          while (1) {
            switch (_context44.prev = _context44.next) {
              case 0:
                if (bitId.isLocal(this.name)) {
                  _context44.next = 2;
                  break;
                }

                throw new (_generalError || _load_generalError()).default('cannot run build on remote component');

              case 2:
                _context44.next = 4;
                return this.loadComponent(bitId);

              case 4:
                component = _context44.sent;
                return _context44.abrupt('return', component.build({
                  scope: this,
                  save,
                  consumer,
                  verbose,
                  directory,
                  keep
                }));

              case 6:
              case 'end':
                return _context44.stop();
            }
          }
        }, _callee44, this);
      }));

      function build(_x68) {
        return _ref55.apply(this, arguments);
      }

      return build;
    }()

    /**
     * import a component end to end. Including importing the dependencies and installing the npm
     * packages.
     *
     * @param {string} bitId - the component id to isolate
     * @param {IsolateOptions} opts
     * @return {Promise.<string>} - the path to the isolated component
     */

  }, {
    key: 'isolateComponent',
    value: function () {
      var _ref56 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee45(bitId, opts) {
        var parsedId, component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee45$(_context45) {
          while (1) {
            switch (_context45.prev = _context45.next) {
              case 0:
                parsedId = (_bitId || _load_bitId()).BitId.parse(bitId);
                _context45.next = 3;
                return this.loadComponent(parsedId);

              case 3:
                component = _context45.sent;
                return _context45.abrupt('return', component.isolate(this, opts));

              case 5:
              case 'end':
                return _context45.stop();
            }
          }
        }, _callee45, this);
      }));

      function isolateComponent(_x69, _x70) {
        return _ref56.apply(this, arguments);
      }

      return isolateComponent;
    }()
  }, {
    key: 'groupName',
    get: function get() {
      if (!this.scopeJson.groupName) return null;
      return this.scopeJson.groupName;
    }
  }, {
    key: 'name',
    get: function get() {
      return this.scopeJson.name;
    }
  }], [{
    key: 'getComponentsRelativePath',
    value: function getComponentsRelativePath() {
      return (_constants || _load_constants()).BITS_DIRNAME;
    }

    /**
     * Get a relative (to scope) path to a specific component such as compiler / tester / extension
     * Support getting the latest installed version
     * @param {BitId} id
     */

  }, {
    key: 'getComponentRelativePath',
    value: function getComponentRelativePath(id, scopePath) {
      var realtivePath = (_path || _load_path()).join(id.box, id.name, id.scope);
      if (!id.getVersion().latest) {
        return (_path || _load_path()).join(realtivePath, id.version);
      }
      if (!scopePath) {
        throw new Error(`could not find the latest version of ${id} without the scope path`);
      }
      var componentFullPath = (_path || _load_path()).join(scopePath, Scope.getComponentsRelativePath(), realtivePath);
      if (!(_fsExtra || _load_fsExtra()).default.existsSync(componentFullPath)) return '';
      var versions = (_fsExtra || _load_fsExtra()).default.readdirSync(componentFullPath);
      var latestVersion = (_semver || _load_semver()).default.maxSatisfying(versions, '*');
      return (_path || _load_path()).join(realtivePath, latestVersion);
    }
  }, {
    key: 'ensure',
    value: function ensure(path, name, groupName) {
      if (pathHasScope(path)) return this.load(path);
      if (!name) name = (0, (_utils || _load_utils()).currentDirName)();
      var scopeJson = new (_scopeJson || _load_scopeJson()).ScopeJson({ name, groupName, version: (_constants || _load_constants()).BIT_VERSION });
      return Promise.resolve(new Scope({ path, created: true, scopeJson }));
    }
  }, {
    key: 'reset',
    value: function () {
      var _ref57 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee46(path, resetHard) {
        return (_regenerator || _load_regenerator()).default.wrap(function _callee46$(_context46) {
          while (1) {
            switch (_context46.prev = _context46.next) {
              case 0:
                if (!resetHard) {
                  _context46.next = 4;
                  break;
                }

                (_logger || _load_logger()).default.info(`deleting the whole scope at ${path}`);
                _context46.next = 4;
                return (_fsExtra || _load_fsExtra()).default.emptyDir(path);

              case 4:
              case 'end':
                return _context46.stop();
            }
          }
        }, _callee46, this);
      }));

      function reset(_x71, _x72) {
        return _ref57.apply(this, arguments);
      }

      return reset;
    }()
  }, {
    key: 'load',
    value: function () {
      var _ref58 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee47(absPath) {
        var scopePath, path, scopeJson;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee47$(_context47) {
          while (1) {
            switch (_context47.prev = _context47.next) {
              case 0:
                scopePath = (0, (_utils || _load_utils()).propogateUntil)(absPath);

                if (scopePath) {
                  _context47.next = 3;
                  break;
                }

                throw new (_exceptions || _load_exceptions()).ScopeNotFound();

              case 3:
                if ((_fsExtra || _load_fsExtra()).default.existsSync((_path || _load_path()).join(scopePath, (_constants || _load_constants()).BIT_HIDDEN_DIR))) {
                  scopePath = (_path || _load_path()).join(scopePath, (_constants || _load_constants()).BIT_HIDDEN_DIR);
                }
                path = scopePath;
                _context47.next = 7;
                return (_scopeJson || _load_scopeJson()).ScopeJson.loadFromFile((0, (_scopeJson || _load_scopeJson()).getPath)(scopePath));

              case 7:
                scopeJson = _context47.sent;
                return _context47.abrupt('return', new Scope({ path, scopeJson }));

              case 9:
              case 'end':
                return _context47.stop();
            }
          }
        }, _callee47, this);
      }));

      function load(_x73) {
        return _ref58.apply(this, arguments);
      }

      return load;
    }()
  }]);

  return Scope;
}();

exports.default = Scope;